package ee.ut.cs.gitlab.maikov.expressions;

import ee.ut.cs.gitlab.maikov.exceptions.InvalidReductionException;
import ee.ut.cs.gitlab.maikov.matrix.Matrix;

// Use Exponentiation with NaN as the power.
@Deprecated
public class MatrixTranspose extends Expression {
    private final Expression expr;

    public MatrixTranspose(Expression expr) {
        this.expr = expr;
    }

    @Override
    public Expression compute() {
        Expression expr = this.expr.compute();
        if (expr instanceof MatrixValue matrixValue) {
            Matrix matrix = matrixValue.getMatrix();
            Matrix transpose = matrix.transpose();
            return new MatrixValue(transpose);
        } else {
            throw new InvalidReductionException();
        }
    }
}
